#define		PROTECT
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"kawkfunc.h"
/*EXTERN*/
/**/
void
oneptr(na,ap,fu)	/* one pointer argument; pointer return */
int		na;			/* number of arguments */
DATUM	*ap;		/* argument pointer */
FUNCP	fu;			/* function pointer */
{
	rdx.v.ptr = (char *) (*fu)(ap[0].v.ptr);
	pusher = spush;
}
void
kkgetenv(na,ap)
int     na;
DATUM   *ap;
{
	oneptr(na,ap,(FUNCP) kgetenv);
}
void
kstrcnd(na,ap)
int     na;
DATUM   *ap;
{
	oneptr(na,ap,(FUNCP) strcnd);
}
void
kstrncpy(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strncpy(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ivalu);
    pusher = spush;
}
void
kundater(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = undater(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,ap[2].v.ptr);
    pusher = spush;
}
void
kdater(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = dater(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,ap[2].v.ptr);
    pusher = spush;
}
void
kstrcpy(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strcpy(ap[0].v.ptr,ap[1].v.ptr);
    pusher = spush;
}
void
kstrcat(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strcat(ap[0].v.ptr,ap[1].v.ptr);
    pusher = spush;
}
void
kstrncat(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strncat(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ivalu);
    pusher = spush;
}
void
korlist(na,ap)
int     na;
DATUM   *ap;
{
    REG     int     nax;
    rdx.v.ptr = NULL;
    for(nax = 0; nax < na; nax++)	{
    if(isnull(ap[nax].v.ptr))     ;
    else    {
        rdx.v.ptr = ap[nax].v.ptr;
        break;
        }
	}
    pusher = spush;
}
void
kisnull(na,ap)
int     na;
DATUM   *ap;
{
	rdx.v.ivalu = isnull(ap[0].v.ptr);
    pusher = ipush;
}
void
kstrupr(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strupr(ap[0].v.ptr);
    pusher = spush;
}
void
kstrlwr(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ptr = strlwr(ap[0].v.ptr);
    pusher = spush;
}
void
katof(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.dvalu = atof(ap[0].v.ptr);
	pusher = dpush;
}
void
katoi(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = atoi(ap[0].v.ptr);
    pusher = ipush;
}
void
kexit(na,ap)
int     na;
DATUM   *ap;
{
	auto	int		ret = na ? ap[0].v.ivalu : 0;
/*
	if interactive, stop execution, otherwise exit.  calling terror may cause
	problems.
*/
    if(kenv.prompt) terror( ret );
	else			exit( ret );
}
void
kxgnc(na,ap)
int     na;
DATUM   *ap;
{
	auto	char	*os = ap[0].v.ptr;
	auto	char	*us = os + ap[1].v.ivalu;
	auto	char	*is = ap[2].v.ptr;
	auto	int		cx = ap[3].v.ivalu;
    rdx.v.ptr = xgnc(os,us,is,cx);
    pusher = spush;
}
void
kgetqs(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = getqs((char **) ap[0].v.ptr,ap[1].v.ivalu,ap[2].v.ptr);
    pusher = ipush;
}
void
ksplitc(na,ap)
int     na;
DATUM   *ap;
{
/*
	necessary to simply call to avoid heap space message
*/
	auto	char	**xp = (char **) ap[0].v.ptr;
	auto	int		nxp = ap[1].v.ivalu;
	auto	char	*is = ap[2].v.ptr;
	auto	int		cx = ap[3].v.ivalu;
/**/
	rdx.v.ivalu = splitc(xp,nxp,is,cx);
/**/
    pusher = ipush;
}
void
kstrcmp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = strcmp(ap[0].v.ptr,ap[1].v.ptr);
    pusher = ipush;
}
void
kstrncmp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = strncmp(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ivalu);
    pusher = ipush;
}
/**/
void
krand(na,ap)
int		na;
DATUM	*ap;
{
	static	NOSIGN	seed = 0;
	if(!seed)	seed = (NOSIGN) time( (int *) NULL );
	rdx.v.ivalu = rand();
	pusher = ipush;
}
void
kstricmp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = stricmp(ap[0].v.ptr,ap[1].v.ptr);
    pusher = ipush;
}
void
kstrnicmp(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = strnicmp(ap[0].v.ptr,ap[1].v.ptr,ap[2].v.ivalu);
    pusher = ipush;
}
