#define			FINDSORT
#include        "ksysdefs.h"
#include        "ksysvtyp.h"
#include        "ksysprot.h"
#define			ALLOCATE
#include        "ksyskord.h"
#include        <signal.h>
#include        <setjmp.h>
/**/
#ifdef		SORTSEP
#undef		SORTSEP
#define		SORTSEP		'='
#endif		/*SORTSEP*/
/**/
extern	FUNCP	ignore();
/**/
jmp_buf jump;
/**/
void
terror(ty)
int		ty;
{
/**/
	if(error++ >= BUFSIZ)	exit(FUBAR);
/**/
	signal(ty,SIG_IGN);
/**/
    efclean(NULL);
    cleanup();
/**/
    kenv.prompt = first && kenv.prompt && isatty(0) && isatty(1) ? 1 : 0;
/**/
    if(kenv.prompt)     {
		signal(ty,(FUNCS) terror);
        efclean(NULL);
		fputs("\n",stderr);
        errmsg("terror(%u)\n",ty);
		fflush(stdout);
		fflush(stderr);
        longjmp(jump,1);
        }
    else            exit(ty);
/**/
}
main(argc,argv)
int     argc;
char    *argv[];
{
	scx = sc;
	scu = sc + BLKSIZ - 1;
	kenv.dosdos = isdos();
	disnme(kenv.pname = "kord");
	exit(cmdxrc(argc,argv,kord,"kord.xrc"));
	return(0);	/* LINT */
}
kord(argc,argv)
int	argc;
char	*argv[];
{
/**/
	if(cmderr(argc,argv,"BDORSTWehikop0123456789"))	{
		exit(FUBAR);
		}
/**/
    if(!kenv.dosdos)	{
        telluser(kenv.pname);
        kenv.report = cmdnum(argc,argv,'R',DA,DA);
        disrec(1);
    }
	else	cmdxpd(argc,argv);
/**/
	kenv.blockd = cmdnum(argc,argv,'B',4,4) * bufsiz();
/**/
	kenv.prompt = isatty(0);
/**/
	kenv.leisur = isatty(1) ? ( DA | DB) : 0;
/**/
    if(cmdnum(argc,argv,'h',0,1))   {
		if(kenv.leisur)	{
        	whoru(stdout);
			query(stdout);
			}
		exit(hint(ZERO));
        }
/**/
    kenv.diagno = cmdnum(argc,argv,'D',0,DA);
/**/
	biblsort = cmdstr(argc,argv,'S',kgetenv("SORTER"));
/**/
	if(isnull(biblsort))	{
		if(kenv.dosdos)		biblsort = strsave("sort.exe");
		else				biblsort = strsave("sort");
		}
/**/
#ifdef	FINDSORT
	if(findsort(biblsort))	exit(FUBAR);
#endif	/*FINDSORT*/
/**/
	tmpdir = cmdstr(argc,argv,'T',kgetenv("TMPDIR"));
/**/
	if(isnull(tmpdir))
		tmpdir = kenv.dosdos ? "." : "/usr/tmp" ;
/**/
/*
**	make each file so subsequent calls do not repeat the name
**	because no such file exists.
*/
/**/
	kenv.flags0 = cmdnum(argc,argv,'p',DA,DA);
/**/
    kenv.prompt = cmdnum(argc,argv,'i',isatty(0),1);
	kenv.folder = FOLD;
	kenv.leisur = (isatty(1) && (baudrate(stdout) >= 1200)) ? (DA|DB) : 0;
/**/
    if(cmdnum(argc,argv,'e',0,DA))  {
        strcpy(ecmd,cmdstr(argc,argv,'e',""));
        kenv.leisur = kenv.prompt = 0;
        }
/**/
    keysread(keysfile(cmdstr(argc,argv,'k',NULL)));
/**/
    outlist(argc,argv);
/**/
    rcmdlist(argc,argv);    /* must be last */
/**/
    if(signal(SIGINT,SIG_IGN) != SIG_IGN) 	{
#ifdef	MSDOS
#else
		signal(SIGHUP,(FUNCS) terror);
#endif
		signal(SIGINT,(FUNCS) terror);
		}
	else	kenv.prompt = NO;
/**/
    setjmp(jump);
/**/
    if(!isnull(ecmd))   doexpr(ecmd);
    else                {
		if(first == ZERO)	{
			if(kenv.prompt)	{
				whoru(stdout);
				query(stdout);
				}
			first = 1;
			}
		tgetcmd(ls,ls+BLKSIZ-1,stdin);
		}
/**/
    cleanup();
    exit(0);
	return(0);
}
void
callsort(os,us)           /* make shell script for sort command */
char	*os;
char	*us;
{
    auto    char    fs[BLKSIZ];
    auto    int     i;
    auto    char    *osx = os;
    auto    char    *usx = us;
	auto	int		lc;
/**/
#ifdef	SUN
    sprintf(fs,"%s -T %s -o %s -t%c ",biblsort,tmpdir,xfn,SORTSEP);
#else	/*SUN*/
    sprintf(fs,"%s -o %s -t%c ",biblsort,xfn,SORTSEP);
#endif	/*SUN*/
/**/
    osx = strkat(osx,usx,fs);
/**/
    for(i = 0; i < nsorts; i++) {
        if(ksx[i].nks <= 0) {
            errmsg("<undefined sort> s%d\n",i+1);
            terror(FUBAR);
            }
        if(isnull(ksx[i].sc))   dump("ksx[i].sc");
        sprintf(fs,"+%d%s -%d ",i+SORTOFF,ksx[i].sc,i+1+SORTOFF);
        osx = strkat(osx,usx,fs);
    }
/**/
    sprintf(fs," %s",xfn);
/**/
    osx = strkat(osx,usx,fs);
	lc = strlen(os);
	if(kenv.dosdos && lc >= (FNMSIZ-2))	{
		errmsg("callsort <command too long for MiSerable DOS>\n");
		fputlf(os,stderr,kenv.folder);
		terror(FUBAR);
		}
	else
	if(kenv.dosdos == 0 && lc >= BUFSIZ)	{
		errmsg("callsort <command too long>\n");
		fputlf(os,stderr,kenv.folder);
		terror(FUBAR);
		}
}
char    *
dowds(is,nw)    /* limit number of words */
char    *is;
int     nw;
{
    REG         char    *isx = is;
    REG         int     nwx = 0;
    strcnd(isx);
    for( ; *isx != ZERO; isx++)
    if(isspace(*isx)) {
        if(++nwx >= nw)             break;
        while(isspace(*isx))        isx++;
        }
    *isx = ZERO;
    return(is);
}
/**/
dosort(os,us)
char    *os;
char    *us;
{
    auto    int     ret = 0;
    auto    int     inc = 0;
/**/
	strcpy(wfn,tmpdir);
	strcpy(xfn,tmpdir);
	strcat(wfn,KORDWORK);
	strcat(xfn,KORDWORK);
    maketemp(xfn);
    maketemp(wfn);
/**/
	if(!isnull(os))	{
		doso(os,us);
		return(ZERO);
		}
/**/
    cansort();
/**/
    callsort(scx,scu);		/* make sort command */
/**/
    if(kenv.prompt) printff("%-20.20s\r","<indexing>");
/**/
    inc = in_cards = makework(ifn);
/**/
    if(inc <= 0)    {
        errmsg("dosort <no input>\n");
        terror(FUBAR);
        }
/**/
    if(!isnull(acmd))   ret = doshell(acmd+1,xfn,NULL);
    if(ret)             badcmd(acmd+1);
/**/
    if(kenv.prompt)     printff("%-20.20s\r","<sorting>");
    if(!isnull(scx))    ret = gofork(scx);
    if(ret)             badcmd(scx);
/**/
    if(!isnull(bcmd))   ret = doshell(bcmd+1,xfn,NULL);
    if(ret)             badcmd(bcmd+1);
/**/
    if(kenv.prompt)     printff("%-20.20s\r","<rebuilding>");
/**/
	rebuild();
/**/
    return(0);
}
canread(is)		/* read permission? */
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	auto	NOSIGN	err = 0;		/* err cnt */
	while(isx = xgnc(ws,ws+FNMSIZ-1,isx,' '))	{
		if(access(ws,04))	{
			errmsg("canread <bad file> '%s'\n",ws);
			err += 1;
			}
		}
	return(err);
}
setjoin(is)
char    *is;
{
    switch(*is)
    {
    case    'J':
    case    NULL:   join = 0;
    when    'a':    join = *is;
    when    'o':    join = *is;
    when    's':    join = *is;
                    break;
    default:        errmsg("<bad command> 'j%s'\n",is);
                    terror(FUBAR);
    }
    return(0);
}
/**/
makework(is)    /* make work file for sort */
char	*is;	/* input files */
{
	auto	char		ws[FNMSIZ];
	auto	NOSIGN		cn = 0;
	auto	NOSIGN		tc = 0;
	auto	long		fa = 0L;
/**/
    xfp = tefopen(xfn,"w");
	wfp = tefopen(wfn,"w");
/**/
	while((int)(is = xgnc(ws,ws+FNMSIZ-1,is,' ')))	{
	cn = 0;
	rfp = tefopen(ws,"r");
/**/
		while(!feof(rfp))	{
/**/
		if(kenv.prompt && !(cn % 100))	{
			printff("%-14.14s%6d\r"," ",cn);
			}
/**/
		clcd();
/**/
        if(rdcd(rfp,'v') == ZERO)           {
            badcard(ws,rfp,cn,fa);
            break;
            }
/**/
		fa = ftell(wfp);
		wrcd(wfp,'w',0);
/**/
        wrsort(xfp,fa);
/**/
		cn += 1;
        }
/**/
	xfclose(rfp);
	if(kenv.prompt)	{
		printf("%d card(s) from %s\n",cn,ws);
		}
	tc += cn;
	}
/**/
	wfp = xfclose(wfp);
	xfp = xfclose(xfp);
/**/
	return(tc);
}
/**/
parsecmd(os,us)
char    *os;
char    *us;
{
    auto    char    *osx = os + 1;
    strcnd(osx);
    switch(*os)
    {
    case    ':':
    when    NULL:
	when	'A':	findsort(osx);
    when    'a':    setcmd(acmd,osx);
	when	'B':	kenv.blockd = atoi(osx);
					kenv.blockd = kenv.blockd ? kenv.blockd : 1;
					kenv.blockd *= bufsiz();
    when    'b':    setcmd(bcmd,osx);
	when	'C':	scr_cl(stdout);
	when	'E':	getlerr(stderr);
    when    'c':    clrsort(osx);
    when    'e':    xso(osx);
    when    'M':    keysmem(stdout);
    when    'D':    if(os[1])   kenv.diagno = atoi(osx);
    case    'F':
    case    'f':    filelist(NULL);
    when    '?':    hint(ZERO);
    when    'g':    dosort(osx,us);
    when    'h':    system("khelp kord");
    when    'j':    
    case    'J':    setjoin(osx);
    case    'K':    
    when    'k':    newkeys(osx);
    when    'l':    listing(ofn);
    when    'L':    listing(ifn);
    when    'O':
    case    'W':
    case    'w':
    case    'o':    setofn(os,us);
    when    'q':    fclose(stdin);
                    cleanup();
                    exit(atoi(osx));
    when    'r':    setifn(osx);
    when    'S':    zapsort(osx);
    when    's':    setsort(osx,us);
    when    'T':    twrset(osx,us);
    when    'u':    uniq = 1;
    when    'U':    uniq = 0;
    when    '!':    doshell(osx,ofn,ifn);
                    break;
    default:        strcnd(os);
                    if(!isnull(os))
                        errmsg("<unknown command> '%s'\n",os);
                    break;
    }
    return(0);
}
tgetcmd(os,us,fp)
char    *os;
char    *us;
FILE    *fp;
{
    auto    int     pr = isatty(fileno(fp));
    for( ; ; ) {
    if(pr)  {
        scr_so(stdout);
        printff("(%s)=>",kenv.pname);
        scr_se(stdout);
        }
    if(!fgetlf(os,us,fp)) {
        if(pr)  {
            clearerr(fp);
            errmsg("<use q to quit>\n");
            continue;
            }
        else    {
            return(0);
            }
        }
    if(othercmd(os,us)) continue;
    else                parsecmd(os,us);
    }
}
/**/
rebuild()  		/* recreate records from the work (index) file */
{
	auto	int		uq = 0;
	auto	int		po = 0;			/* pause output */
	auto	int		fn = 0;			/* file number */
	auto	long	fa = 0L;		/* file address */
	auto	int		rt;
/**/
	rd_cards = ot_cards = ZERO;
/**/
	if(filesize(xfn) <= 0)	{
		errmsg("rebuild <bad file> '%s'\n",xfn);
		terror(FUBAR);
		}
/**/
	wfp = tefopen(wfn,"r");
    xfp = efopen(xfn,"r");
/**/
	if(isnull(ofn) || *ofn == '-')	{
		ofp = stdout;
		po = isatty(fileno(stdout)) && (kenv.leisur & (DA | DB));
		}
	else 							{
		ofp = tefopen(ofn,"w");
		}
/**/
	while(!ferror(ofp))	{
/**/
    if(!fgetlf(ls,&ls[BLKSIZ-1],xfp))	{
		if(fgetlerr())	{
			errmsg("rebuild <index line too long>\n");
			terror(FUBAR);
			}
		else	break;
		}
/**/
	if(strlen(ls) <= 0)	continue;		/* damn dos */
/**/
	if(kenv.prompt)	{
		if(rd_cards % 100 == ZERO)	{
			auto	long	percent = rd_cards;
			percent *= 100;
			percent /= in_cards;
			printff("%11.11s%6u %2ld%%\r"," ",rd_cards,percent);
			}
		}
/**/
    if(ls[0] != SORTSEP) {
		/* user has munged the work file */
        errmsg("<bad work file>");
		funxesc(ls,stderr);
        print("(%s)\n",ls);
        terror(FUBAR);
        }
/**/
	sscanf(ls,"=%ld=%d",&fa,&uq);
/**/
    if(uniq && uq && strkmp(ls+12,ps) == 0)    ;
    else
    if(join && uq && strkmp(ls+12,ps) == 0)    {
			efseek(wfp,fa,0);
			if(rdcd(wfp,join) == ZERO)	terror(FUBAR);
			rd_cards += 1;
            }
    else {
			if(po)	{
				rt = wrcd(ofp,'f',kenv.folder);
				if(query(ofp) == 'q')	terror(FUBAR);
				}
            else	rt = wrcd(ofp,'w',0);
			if(rt)	ot_cards += 1;
			efseek(wfp,fa,0);
            clcd();
			if(rdcd(wfp,'o') == ZERO)	terror(FUBAR);
			rd_cards += 1;
	}
/**/
	if(ferror(ofp))		break;
/**/
    if(uniq || join)    strcpy(ps,ls+12);
    }
/*	flush last record out */
	if(!nullcd())	{
		if(po)	rt = wrcd(ofp,'f',kenv.folder);
		else	rt = wrcd(ofp,'w',0);
		if(rt)	ot_cards += 1;
	}
/**/
	wfp = xfclose(wfp);
	unlink(wfn);
	xfp = xfclose(xfp);
	unlink(xfn);
/**/
	if(ferror(ofp))	{
		errmsg("rebuild <write error: no space?>\n");
		terror(FUBAR);
		}
/**/
	if(ofp != stdout)	{
		xfclose(ofp);
		if(kenv.prompt)	{
			printf("%d cards in %d cards out %s\n",rd_cards,ot_cards,ofn);
			}
		}
/**/
    return(rd_cards);
}
zapsort(is)     /* cancel all sorts */
char    *is;
{
	is[0] = is[0];
    if(kenv.prompt)
        printff("\007sorts cancelled\007\n");
    return(nsorts = 0);
}
setsort(os,us)
char    *os;
char    *us;
{
    REG     char    *isx = NULL;
    REG     char    *osx = NULL;
    auto    char    ws[BLKSIZ];
    auto    char    *cp[2];
    auto    int     ns = 0;
/***save the command for diagnostics***/
    strcpy(ws,os);
    strxty(os,'|',',');
    strcnd(os);
    if(!isdigit(*os))      {
        errmsg("<bad syntax> '%s'\n",ws);
        terror(FUBAR);
        }
    ns = atoi(os) - 1;
    while(isdigit(*os))  os++;
    if(ns >= NSORTS || ns < 0) {
        errmsg("<bad sort> '%s'\n",ws);
        terror(FUBAR);
        }
/***get the key list***/
    splitc(cp,2,os,'/');
	strcnd(cp[0]);
	if(isnull(cp[0]))	{
		errmsg("<no key list>\n");
		terror(FUBAR);
		}
    ksx[ns].nks = keylist(ksx[ns].kl,NLIST,cp[0],',');
    if(ksx[ns].nks <= 0) {
        errmsg("<bad key in list> '%s'\n",ws);
        terror(FUBAR);
        }
/***get the option specifications***/
    ksx[ns].rc[0] = ksx[ns].sc[0] = ZERO;
    strcpy(ksx[ns].rc,ws);
    isx = cp[1];
    if(isnull(isx)) {
        isx = "dfbe";
        strcat(ksx[ns].rc,"/");
        strcat(ksx[ns].rc,isx);
        if(kenv.prompt) {
            printff("<added sort specification> '%s'\n",isx);
            }
        }
    osx = ksx[ns].sc;
    while(*isx != ZERO) {
        switch(*isx) {
        case    'd':    ksx[ns].opt |= SDICT;
                        *osx++ = *isx++;
        when    'f':    ksx[ns].opt |= SFOLD;
                        *osx++ = *isx++;
        when    'n':    ksx[ns].opt |= SNUMB;
                        *osx++ = *isx++;
        when    'r':    ksx[ns].opt |= SREVR;
                        *osx++ = *isx++;
        when    'u':    ksx[ns].opt |= SUNIQ;
                        *osx++ = *isx++;
        when    'b':    ksx[ns].opt |= SBLNK;
                        *osx++ = *isx++;
        when    'e':    ksx[ns].opt |= SARTS;
                        isx += 1;
        when    'z':    ksx[ns].opt |= SZZZZ;
                        isx += 1;
        when    't':    ksx[ns].opt |= STIME;
                        isx += 1;
        when    'l':    ksx[ns].opt |= SLIMT;
                        ksx[ns].lmt = atoi(++isx);
                        if(ksx[ns].lmt <= 0)    ksx[ns].lmt = 64;
                        while(isdigit(*isx))    isx++;
        when    'w':    ksx[ns].opt |= SWORD;
                        ksx[ns].wds = atoi(++isx);
                        if(ksx[ns].wds <= 0)    ksx[ns].wds = 3;
                        while(isdigit(*isx))    isx++;
                        break;
        default:        errmsg("<no option> '%c'\n",*isx);
                        print("%s\n",ws);
                        terror(FUBAR);
                        break;
        }
    }
    *osx = ZERO;
    if((ns+1) > nsorts) nsorts = ns+1;
    return(ns);
}
clrsort(is)  /* null sort list */
char    *is;
{
        return(nsorts = atoi(is));
}
dolmt(is,nc)        /* limit is to nc characters */
char    *is;
NOSIGN   nc;
{
    REG     char    *isx = is;
    REG     int     ncx = nc;
    while(*isx != ZERO && ncx-- >= 1)   ++isx;
    *isx = ZERO;
    return(nc-ncx);
}
wrsort(ofp,pos)
FILE	*ofp;
long	pos;
{
		auto	int		i;
		auto	int		j;
		auto	int		uniq = 1;
		auto	char	os[BLKSIZ];
		auto	char	*osx = os;
		auto	char	*usx = os + BLKSIZ -1;
		auto	char	*tx;
		auto	char	scz[2];
		scz[0] = SORTSEP;
		scz[1] = 0;
		for(i = 0; i < nsorts; i++)	 {
/***put in the sort separator***/
		osx = strkat(osx,usx,scz);
/***find the first non-null field***/
		for(tx = NULL, j = 0; !tx && j < ksx[i].nks; j++) {
		tx = kd[ksx[i].kl[j]].data;
		}
/***write "zzzzz" or null as specified***/
		if(!tx)	{
			if(ksx[i].opt & SZZZZ)	osx = strkat(osx,usx,"zzzzz");
			else					osx = strkat(osx,usx,"");
			uniq = 0;
			continue;
			}
/*		do a time conversion ***/
		if(ksx[i].opt & STIME)		{
			osx = strkat(osx,usx,sortdate(tx));
			continue;
			}
/*		zap articles ****/
		if(ksx[i].opt & SARTS)		zart(tx);
/*		limit length ****/
		if(ksx[i].opt & SLIMT)		dolmt(tx,ksx[i].lmt);
/*		limit the word count***/
		if(ksx[i].opt & SWORD)		dowds(tx,ksx[i].wds);
		osx = strkat(osx,usx,tx);
		}
/*      check for overflow */
		if(osx >= (usx - 10))	{
			errmsg("wrsort <index line too long>\n");
			fputlf(os,stderr,kenv.folder);
			print("use lNN or wNN sort options to shorten\n");
			query(stderr);
			terror(FUBAR);
			}
/*		write the sucker***/
		fprintf(ofp,"%c%08ld",SORTSEP,pos);
		fprintf(ofp,"%c%1d%s\n",SORTSEP,uniq,os);
/**/
		if(ferror(ofp))	{
			errmsg("wrsort <write error: no space>?\n");
			terror(FUBAR);
			}
/**/
		return(0);
}
