#include	"krheader.h"
/*EXTERN*/
/*GLOBAL*/
/**/
setrdr(ty)		/* set the input routine */
{
	if(ty == 'k')	reader = xrdcd;
	else	
	if(ty == 'l')	reader = fgetlf;
	else			dump("setrdr");
	return(ty);
}
char	*
setcbo(nc)		/* set the context buffer */
{
	if(cbo)	free(cbo);
	cbo = emalloc(nc,"setcbo");
	cbu = cbo + nc;
	memnull(cbo,nc);
	return(cbo);
}
context(is,cen)		/* show context of 'word' */
int     cen;
char    *is;
{
	auto	char	*pat;
	auto	char	ws[BUFSIZ];
	auto	char	*isx = rfn;
	auto	int		loop = YES;
/**/
	hits = 0;
/**/
	nofile();
/**/
	if(*is == '/')  pat = is + 1;
#ifndef	TEST
	else            pat = xl.err;
#endif
	if(isnull(pat)) {
		errmsg("<context: bad pattern>\n");
		terror(FUBAR);
		}
	if(re_comp(pat))	{
		errmsg("<bad pattern> '%s'\n",pat);
		terror(FUBAR);
		}
	while(loop == YES && (int)(isx = xgnc(ws,ws+BUFSIZ-1,isx,' ')))	{
		strcnd(ws);
		strcpy(cbo,ws);
		loop = sweep(cbo,cbu);
		}
	return(ZERO);
}
sweep(os,us)		/* recursively search for pattern */
char	*os;
char	*us;
{
	auto	FILE	*ifp;
	auto	struct	PATLOC	*pdq;
	auto	int		ln = 0;
	auto	int		loop = YES;
	auto	char	fn[FNMSIZ];
	auto	char	*rmode = kenv.dosdos ? "rb" : "r";
/**/
	if(access(os,04))	{
		fprintf(stderr,"<cannot find> %-60.60s\r",os);
		return(loop);
		}
/**/
	ifp = efopen(os,rmode);
	strkat(fn,fn+FNMSIZ-1,os);
/**/
	while(loop == YES && !feof(ifp))	{
		ln += 1;
		if(!(*reader)(os,us,ifp))	break;
		if((int)(pdq = re_ploc(os)))	{
			loop = showpat(fn,ln,os,pdq);
			}
		else
		if(os[0] == '.' && strncmp(os,".so ",4) == 0)	{
			strcpy(os,os+4);
			strcnd(os);
			sweep(os,us);
			}
	}
/**/
	ifp = xfclose(ifp);
	return(loop);
}
showpat(fn,ln,is,pdq)
char	*fn;			/* file name */
int		ln;				/* line number */
char	*is;			/* line with pattern */
struct	PATLOC	*pdq;	/* pointer to match */
{
	REG		char	*isx = is;
	REG		char	*pdb = pdq->beg;
	REG		char	*pde = pdq->end;
	REG		int		fwx = kenv.folder;
	REG		int		fwc = 0;
	auto	int		so = ZERO;
	auto	int		loop = YES;
/**/
	hits += 1;
/**/
	if(kenv.leisur & DA)		{
		if(reader == fgetlf)	{
			if(hits == 1)		scr_cl(stdout);
			}
		else
		if(reader == xrdcd)		scr_cl(stdout);
		}
/**/
	fprintf(stdout,"%s (%d)\n",fn,ln);
/**/
	while(*isx != ZERO)	{
	if(*isx == LF)		{
		fwc = 0;
		if(so)				{scr_se(stdout);so = 0;}
		putc(LF,stdout);
		while(isspace(*isx))	++isx;
		continue;
		}
	if(isspace(*isx) && fwc >= fwx)	{
		fwc = 0;
		if(so)				{scr_se(stdout);so = 0;}
		putc(LF,stdout);
		while(isspace(*isx))	++isx;
		continue;
		}
	if(isx == pdb)			{scr_so(stdout);so = 1;}
	putc(*isx,stdout);
	fwc += 1;
	if(isx == pde)			{scr_se(stdout);so = 0;}
	isx += 1;
	}
/**/
	scr_se(stdout);
/**/
	putc(LF,stdout);
/**/
	fflush(stdout);
/**/
	if((kenv.leisur & DB) && query(stdout) == 'q')	return(loop = NO);
	else											return(loop = YES);
}
