/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#define		CZ		'\032'
/*EXTERN*/
extern		KENV	kenv;
/*STATIC*/
static		NOSIGN		er;
/**/
#ifndef		FOLD
#define		FOLD		56
#endif
/**/
xrderr()	/* distinguish EOF and errors */
{
	return(er);
}
/**/
char	*
xwrcd(is,fp)
char *is;
FILE *fp;
{
	return(xwrcdf(is,fp,0,NULL));
}
char	*
xwrcdf(is,fp,fw,ts)
char    	*is;		/* input string */
FILE    	*fp;		/* file pointer */
int		fw;			/* fold width */
char		*ts;		/* terminating string (when folding) */
{
	wrf(is,fp,fw,ts);
	fputs("\n",fp);
	fflush(fp);
	if(ferror(fp))	{
		errmsg("xwrcdf <write error: disk full?>\n");
		fubar(FUBAR);
		}
	return(is);
}
char	*
xlwrcdf(is,fp,fw)    /* write card as line; show no print */
char    *is;
FILE    *fp;
{
	wrl(is,fp,fw,NULL);
	fputs("\n",fp);
	fflush(fp);
	return(is);
}
char	*
xrdcd(os,us,fp)
FILE    *fp;
char    *os;
char	*us;
{
	REG		char	*osx = os;
	REG		char	*usx = us - 1;
	REG		int		cx;
	REG		int		lx = 0;
	er = 0;
	while((cx = getc(fp)) != EOF)	{
		if(isspace(cx))	;
		else
		if(cx == EOF)	return(NULL);
		else			break;
		}
	ungetc(cx,fp);
	while(osx < usx && (cx = getc(fp)) != EOF)	{
		if(cx == CR)	;
		else
		if(cx == LF)	{
			if(lx == LF)	break;
			else
			if(lx == '\\')	{
				osx -= 1;
				*osx++ = lx = ' ';
				}
			else	*osx++ = lx = cx;
			}
		else	{
			*osx++ = lx = cx;
			}
		}
	*osx++ = ZERO;
	if(osx >= usx)	{
		er = 1;
		errmsg("xrdcd <overflow>\n");
		/* xlwrcdf(os,stderr,kenv.folder); */
		return(NULL);
		}
	if(cx == EOF)	{
		if(*os == ZERO)	return(NULL);
		}
	return(osx);
}
#ifdef  TEST
KENV	kenv;
void
terror(ty)
int		ty;
{
	exit(ty);
}
main(argc,argv)
int		argc;
char	*argv[];
{
	char    ls[BUFSIZ];
	if(argc >= 2)	freopen(argv[1],"rb",stdin);
	ksetvbuf(stdout,malloc(BUFSIZ * 2),_IOFBF,BUFSIZ * 2);
	ksetvbuf(stdin,malloc(BUFSIZ * 2),_IOFBF,BUFSIZ * 2);
	while(xrdcd(ls,&ls[BUFSIZ-1],stdin))    {
		xwrcd(ls,stdout);
		query(stderr);
		xlwrcdf(ls,stdout,64);
	}
	exit(0);
}
#endif
