#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include    "kawkfunc.h"
/**/
/*EXTERN*/
extern	FILE	*epopen();
/**/
#define		TERMINAL	"/dev/tty"
/**/
#ifdef  		TEST
main()
{
    char    ls[BUFSIZ];
    while(putchar('?'),fflush(stdout),gets(ls))
    switch(ls[0])   {
    case    '!':    system(ls+1);break;
    case    'r':    kusopipe(stdout,ls+1);break;
    case    's':    kuso(stdout,ls+1);break;
    case    'q':    exit(0);break;
    default:        puts("\007??");break;
    }
}
#endif
#ifdef	__MIDDLE__
void
kdrawline(na,ap)
int na;
DATUM   *ap;
{
    REG int ns;
    ns = ap[0].v.ivalu;
    while(ns-- >= 1)
/*###kakuso.c(36) : warning 16: `fputs' : no function return type???*/
        fputs(ap[1].v.ptr,ofp);
/*###kakuso.c(37) : warning 16: `fflush' : no function return type???*/
    fflush(ofp);
    rdx.v.ptr = ap[1].v.ptr;
    pusher = spush;
}
#else
void
kdrawline()
{
	notimp("kdrawline");
}
#endif
void
kslowit(na,ap)	/* call query */
int     na;
DATUM   *ap;
{
    if(na == 1) rdx.v.ivalu = query((FILE *) ap[0].v.ivalu);
    else        
    if(na == 0) rdx.v.ivalu = query(stdout);
    pusher = ipush;
}
#ifdef	__MIDDLE__
void
krdterm(na,ap)
int     na;
DATUM   *ap;
{
    if(!tfp)    {
        tfp = tefopen(TERMINAL,"r");
        }
    rdx.v.ptr = fgetlf(ap[0].v.ptr,ap[0].v.ptr+ap[1].v.ivalu,tfp);
    if(rdx.v.ptr == NULL)  {
        xfclose(tfp);
        }
    pusher = spush;
}
#else
void
krdterm()
{
	notimp("rdterm");
}
#endif
#ifdef	__MIDDLE__
kuso(ofp,is)
FILE    *ofp;
char    *is;
{
    auto    int     cnt = 0;
    auto    int     cx;
    auto    FILE    *ifp;
    auto    char    ws[BUFSIZ];
    auto    char    *wsu = ws + BUFSIZ -1;
    while((int) (is = xgnc(ws,wsu,is,';')))   {
    strcnd(ws);
    ifp = efopen(ws,"r");
    setbuf(ifp,ws);
/*###kakuso.c(94) : warning 16: `_filbuf' : no function return type???*/
    while((cx = fgetc(ifp)) != EOF)  {
/*###kakuso.c(95) : warning 16: `fputc' : no function return type???*/
        fputc(cx,ofp);
        if(cx == '\n')  cnt += 1;
        }
    fflush(ofp);
    xfclose(ifp);
    }
	return(cnt);
}
void
kkuso(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = kuso(ofp,ap[0].v.ptr);
    pusher = ipush;
}
void
ksource(na,ap)
int     na;
DATUM   *ap;
{
    REG     int     cx;
    REG     FILE    *sfp = (FILE *) NULL;
    REG     int     cc = 0;
    sfp = efopen(ap[0].v.ptr,"r");
    while((cx = getc(sfp)) != EOF)  {
        fputc(cx,ofp);
        cc += 1;
        }
    xfclose(sfp);
    fflush(ofp);
    rdx.v.ivalu = cc;
    pusher = ipush;
}
void
kkusopipe(na,ap)
int     na;
DATUM   *ap;
{
    rdx.v.ivalu = kusopipe(ofp,ap[0].v.ptr);
    fflush(ofp);
    xfclose(ofp);
    ofp = stdout;
    pusher = ipush;
}
kusopipe(ofp,is)
FILE    *ofp;
char    *is;
{
    auto    int     cnt = 0;
    auto    int		cx;
    auto    FILE    *pfp;
    auto    char    ib[BUFSIZ];
    if(!(pfp = epopen(strcnd(is),"r"))) terror(FUBAR);
    setbuf(pfp,ib);
    while((cx = getc(pfp)) != EOF)  {
        fputc(cx,ofp);
        if(cx == '\n')  cnt += 1;
        }
    fflush(ofp);
    xfclose(pfp);
    return(cnt);
}
void
kpipe(na,ap)
int     na;
DATUM   *ap;
{
    kpclose(0,0);
    if(!(ofp = epopen(ap[0].v.ptr,"w")))   terror(FUBAR);
    rdx.v.ivalu = 0;
    pusher = ipush;
}
void
kpclose(na,ap)
int     na;
DATUM   *ap;
{
	if(ofp)	xfclose(ofp);
    ofp = stdout;
    rdx.v.ptr = NULL;
    pusher = spush;
}
#else
void
kpipe()
{
	notimp("pipe");
}
void
kpclose()
{
	notimp("pclose");
}
void
kkusopipe()
{
	notimp("kusopipe");
}
void
ksource()
{
	notimp("source");
}
void
kkuso()
{
	notimp("kuso");
}
#endif
