#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#define		ALLOCATE
#include    "kawkdefs.h"
#include	"ksysprot.h"
#include	"keyproto.h"
#include	"kawkfunc.h"
/**/
#include    <signal.h>
#include    <setjmp.h>
/**/
/**/
/*EXTERN*/
extern	void	segerr();
extern	char	*keysget();
/**/
/*STATIC*/
static	NOSIGN		first = ZERO;
static	NOSIGN		error = ZERO;
/*GLOBAL*/
/**/
jmp_buf jump;
/**/
void
terror(ty)
int		ty;
{
/**/
	if(error++ >= FNMSIZ)	exit(FUBAR);	/* too many errors */
/**/
	if(ty != FUBAR)	signal(ty,SIG_IGN);
/**/
	if(kenv.keying)	clcd();
/**/
	efclean(NULL);
/**/
	kenv.prompt = first && kenv.prompt && isatty(0) && isatty(1) ? 1 : 0;
/**/
	if(kenv.prompt)	{
/**/
		if(ty != FUBAR)	signal(ty,terror);
		fputs("\n",stderr);
		errmsg("terror(%u)\n",ty);
		longjmp(jump,ty);
/**/
		}
/**/
	fflush(ofp);
/**/
	exit(ty);
	return;
}
/**/
main(argc,argv)
int     argc;
char	**argv;
{
	if(cmderr(argc,argv,"KRWcdefhikoru"))	exit(FUBAR);
	kenv.dosdos = isdos();
	disnme(kenv.pname = "kawk");
	exit(cmdxrc(argc,argv,kawk,"kawk.xrc"));
}
kawk(argc,argv)
int		argc;
char	*argv[];
{
/**/
	if(kenv.dosdos)	{
		cmdxpd(argc,argv);
		setcbrk(YES);
		}
	else	{
		telluser(kenv.pname);
		disrec(cmdnum(argc,argv,'R',1,0));
		}
/**/
	gargc = argc;
	gargv = argv;
/**/
	setofn(NULL,NULL);
/**/
    kenv.diagno = cmdnum(argc,argv,'d',0,1);
/**/
	setuser(cmduser(argc,argv,'u',NULL));
/*CHECK THIS OUT */
/**/
    kenv.report = cmdnum(argc,argv,'r',0,1);
/**/
	kenv.leisur = isatty(1) ? (DA | DB) : 0;
/**/
	if(cmdnum(argc,argv,'W',0,1))	{
		whoru(stdout);
        exit(0);
		}
    if(cmdnum(argc,argv,'h',0,1))    {
		if(isatty(1))	{
			whoru(stdout);
			query(stdout);
			}
		khint("kawk","");
		exit(0);
        }
/**/
	setcode(cmdnum(argc,argv,'c',MAXPROG,MAXPROG));
/**/
#ifdef	EXPR
    kexp = cmdstr(argc,argv,'e',NULL);
#endif	EXPR
/**/
    formfile(cmdstr(argc,argv,'f',"kawkform"));
	if(ofn = cmdstr(argc,argv,'o',kgetenv("KORDOUT")))	{
		setofn(ofn,"w");
		}
/**/
    kenv.prompt = cmdnum(argc,argv,'i',0,DA | DB);
/**/
    if(signal(SIGINT,SIG_IGN) != SIG_IGN)	{
		signal(SIGINT,terror);
		signal(SIGSEGV,segerr);
#ifdef	__TURBOC__
#else
		signal(SIGALRM,terror);
		signal(SIGPIPE,terror);
		signal(SIGHUP,terror);
		signal(SIGQUIT,terror);
#endif
	}
/**/
	if(first++ <= ZERO)	{
		if(kenv.prompt)	whoru(stdout);
		if(kenv.keying = cmdnum(argc,argv,'K',1,0))
			keysread(keysfile(cmdstr(argc,argv,'k',NULL)));
		cmdfile(argc,argv);
	}
/**/
    setjmp(jump);
/**/
#ifdef	EXPR
    if(kexp)            {
        script(kexp);
		exit(0);
        }
#endif	EXPR
    if(kenv.prompt) while(tgetcmd() != 'q') ;
    else            batch();
	fflush(ofp);
	exit(0);
}
#ifdef	EXPR
char	*
script(is)  /* execute a program from a script */
char    *is;
{
	return(formexec(NULL,is));
}
#endif
batch()     /* execute a program from a file */
{
    return((int) formexec(formnull(),NULL));
}
#ifdef		__MEDIUM__
void
timer()
{
    static  double  last = 0.0;
    static  double  curt = 0.0;
    curt = timetotal();
    print("%.1f ",curt-last);
    last = curt;
	return;
}
#else
void
timer()
{
	notinsml("timer");
	return;
}
#endif		__MEDIUM__
/**/
