#include		"ksysdefs.h"
#include		"ksysvtyp.h"
#include		"ksysprot.h"
/*
*/
extern	char	*sortdate();
extern	char	*stolc();
/*
*/
#define		 DATE_SEP		':'
/*
		if string 's' contains a 'date' return a pointer to
		a static data area containing 'date' converted to a
		number.
*/
char	*
sortdate(is)
REG	 char *is;
{
		static  char	date[BLKSIZ];
		struct {
				int year;
				int month;
				int day;} numdate;
		auto	char	*part[4];
		auto	char	work[BLKSIZ];
		auto	int	wc;
		strkat(work,work+BLKSIZ-1,is);
		numdate.year = numdate.month = numdate.day = 0;
		if(strchr(work,'/'))
				{
/*
		month/day/year format assumed
*/
				wc = splitc(part,4,work,'/');
				numdate.month = atoi(part[0]);
				numdate.day  = atoi(part[1]);
				numdate.year  = atoi(part[2]);
/*### kodate.c(39) : warning 16: `sprintf' : no function return type === */
				sprintf(date,"%04d:%02d:%02d",
						numdate.year,numdate.month,numdate.day);
				return(date);
				}
		wc = splitc(part,4,work,' ');
		/* determine format */
		if(wc == 1 && isdigit(*part[0]))
				{
/*
		1941
*/
				numdate.day = 0;
				numdate.month = 0;
				numdate.year = atoi(part[0]);
				}
		else if(wc == 2 && isalpha(*part[0]) && isdigit(*part[1]))
				{
/*
		Dec 1941
*/
/*### kodate.c(59) : warning 16: `nmonth' : no function return type === */
				numdate.month = nmonth(part[0]);
				numdate.year = atoi(part[1]);
				numdate.day = 0;
				}
		else if (wc == 3 && isalpha(*part[0]) && isdigit(*part[1]))
				{
/*
		Dec 7 1941
*/
				numdate.month = nmonth(part[0]);
				numdate.day = atoi(part[1]);
				numdate.year = atoi(part[2]);
				}
		else if (wc == 3 && isdigit(*part[0]) && isalpha(*part[1]))
				{
/*
		7 Dec 1941
*/
				numdate.day = atoi(part[0]);
				numdate.month = nmonth(part[1]);
				numdate.year = atoi(part[2]);
				}
		else return(is);
		if(numdate.month == -1) return(is);
		/* format date */
		sprintf(date,"%04d:%02d:%02d",numdate.year,numdate.month,numdate.day);
		return(date);
}
static char *seasons[] = {
	"error", "spr", "sum", "fal", "win"
};
static char *month[] = {
	"error", "jan", "feb", "mar",
	"apr", "may", "jun", "jul",
	"aug", "sep", "oct", "nov",
	"dec"
};
static	int	ssize = sizeof(seasons)/sizeof(char*);
static	int	msize = sizeof(month)/sizeof(char*);
nmonth(is)
char	*is;
{
		auto	int	i;
		for(i = 0; i < msize; i++)
			if(strnkmp(is,month[i],3) == 0) 		return(i);
		for(i = 0; i < ssize; i++) 
			if(strnkmp(is,seasons[i],3) == 0) 	return(i * 3);
		return(0);
}
#ifdef		  	TEST
main()
{
		auto	char	is[BLKSIZ];
		auto	char	os[BLKSIZ];
		while(putc('?',stderr),gets(is))
		{
		strcpy(os,sortdate(is));
		puts(is);
		puts(os);
		}
		exit(0);
}
#endif
