/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
char	*
strjoin(os,is,ss)	/* append _is to _os with a blank */
char	*os;		/* previous string */
char	*is;		/* string to append */
char	*ss;		/* separator string */
{
	auto	int		los;
	auto	int		lis;
	auto	int		lss;
/**/
	if(isnull(os))	{
		if(isnull(is))	return(NULL);
		else			return(strsave(is));
		}
/**/
	lis = is ? strlen(is) : 0;
	los = os ? strlen(os) : 0;
	lss = ss ? strlen(ss) : 0;
/**/
	os = erealloc(os,lis + los + lss + 4,"strjoin");
/**/
	if(!os)	{
		errmsg("strjoin <no core>\n");
		fubar(FUBAR);
		}
/**/
/*
	realloc does a blind byte copy.  garbage at the end of an area
	will confuse strcat.  either use strcpy to a specific point or
	force a null as is done here.	
*/
	os[los] = ZERO;
	if(lss)	strcat(os,ss);
	if(lis)	strcat(os,is);
/**/
	return(os);
}		
char	*
stradd(os,is)
char	*os;
char	*is;
{
	return(strjoin(os,is," "));
}
