#include	<stdio.h>
#include	<ctype.h>
#include	<dos.h>
#include	<io.h>
#include	<fcntl.h>
#include	<string.h>
#include	<math.h>
#include	<stdlib.h>
#define	BLKSIZ	512
#define	FNMSIZ	128
#define	SPT		15
/*EXTERN*/
extern int absio(int,int,long,char *,int);
extern int setopt(int, char **);
char	buf[BLKSIZ * SPT];
char	ofn[FNMSIZ];
int		ver;
int		ncw;
int		dri;
int		pos;
int		spt;
int		hed;
int		trk;
int		siz;
int		sec;
main(argc,argv)
int		argc;
char	*argv[];
{
	extern	int		_doserrno;
	auto	int		ix;
	auto	int		ofd;
	setopt(argc,argv);
	ofd = open(ofn, O_WRONLY | O_BINARY | O_CREAT);
	if(ofd < 0)	{
		perror(ofn);
		}
	chmod(ofn,0777);
	absio(0,dri,0,NULL,0);
	for(ix = 0; ix < siz; ix += spt)	{
		if(absio(2,dri,(long) ix,buf,spt) < 0)	{
			perror("absread");
			exit(69);
			}
		/* showbuf(buf); */
		ncw = write(ofd,buf,BLKSIZ * spt);
		if(ncw < 0 || ncw != (BLKSIZ *spt))	{
			perror("write error");
			exit(69);
			}
		}
	exit(0);
	return(0);	/* LINT */
}
absio(fn, drive, blocknr, buff, nblocks)
int 	fn;
int 	drive;
long 	blocknr;
char 	*buff;
int		nblocks;
{
	auto	union REGS 	iregs;
	auto	union REGS 	oregs;
	auto	int 		track;

	iregs.h.ah = fn;
	iregs.h.dl = drive;
	track = (int) (blocknr / (long) spt);
	iregs.h.dh = track & 1;		/* head */
	iregs.h.ch = track >> 1;	/* track */
	iregs.h.cl = (blocknr % spt) + 1;	/* sector */
	iregs.h.al = nblocks;				/* num sectors */
	iregs.x.bx = (int) buff;
	if(fn != 0 && ver >= 1)	{
		fprintf(stderr,"B %4lu ",blocknr);
		fprintf(stderr,"T %4u ",iregs.h.ch);
		fprintf(stderr,"H %4u ",iregs.h.dh);
		fprintf(stderr,"S %4u ",iregs.h.cl);
		fprintf(stderr,"N %4u ",iregs.h.al);
		fprintf(stderr,"\r");
		}

	int86(0x13, &iregs, &oregs);
	if (oregs.x.cflag) {
		fprintf(stderr,
			"absio: error %sing drv %c block %d address %x: bios code %x\n",
			fn==2? "read" : "writ", 'A'+drive, blocknr, buff, oregs.h.ah&0xff);
		fprintf(stderr,"doserrno(%d,%x)\n",_doserrno,_doserrno);
		perror("barf!");
		exit(oregs.h.ah&0xff);
		return(69);	/* LINT */
	}
	else {
		return(0);
	}
}
setopt(argc,argv)
int		argc;
char	*argv[];
{
	auto	int		ix;
	auto	char	*os;
/**/
	strcpy(ofn,"reformat.out");
	ver = 1;
	dri = 0;
	spt = 9;
	trk = 80;
/**/
	for(ix = 1; ix < argc; ix++)	{
		os = argv[ix];
		if(*os++ != '-')	{
			fprintf(stderr,"<option syntax error>\n");
			exit(69);
			}
		while(*os != 0)	{
			if(isdigit(*os))	++os;
			else switch(*os++)	{
				case	'v':	ver = atoi(os);break;
				case	'd':	dri = atoi(os);break;
				case	's':	spt = atoi(os);break;
				case	't':	trk = atoi(os);break;
				case	'o':	strcpy(ofn,argv[++ix]);break;
				default:		fprintf(stderr,"<bad option>\n");
								exit(69);
								break;
				}
			}
		}
/**/
	siz = trk * spt * 2;
	if(ver >= 2)	{
		fprintf(stderr,"%s dri %d trk %d spt %d siz %d\n",
			ofn,dri,trk,spt,siz);
		}
/**/
	return(0);
}
